(* hcd -- solve the Highly Connected Deletion problem
   Copyright (C) 2011, 2012  Falk Hüffner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.  *)

(** Priority search queues with integer as keys, ints as
    priorities, and an arbitraty value stored per key.  *)

(** The type of the queue.  *)
type t
type priority = float


(* The empty queue.  *)
val empty : t

val add : t -> int -> priority -> t
val update : (priority option -> priority) -> t -> int -> t
val update' : (priority -> priority) -> t -> int -> t
val pop : t -> (int * priority * t) option
