(* colcom -- solve the colorful components problem
   Copyright (C) 2011, 2012  Falk Hüffner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.  *)


type vertex = int;;
type weight = int;;
type vertex_set = IntSet.t;;
type neighbors = weight IntMap.t;;
type t = neighbors IntMap.t;;

val empty : t

val add_vertex : t -> vertex -> t

val connect : t -> vertex -> vertex -> weight -> t

val min_cut : t -> IntSet.t * weight

(** [output c g] prints a debug representation of [g] to channel [c].
    O(m) time.  *)
val output : out_channel -> t -> unit
